eratosthenes(N,Ps) :- liste(2,N,Zs), gesiebt(N,Zs,Ps).


/* liste(A,B,Ls) erzeugt die Liste Ls aller natrlichen Zahlen von A bis B. */

liste(X,X,[X]).
liste(A,E,[A|Rs]) :- A < E, A1 is A + 1, liste(A1,E,Rs).


/* gesiebt(N,Zs,Ps) erzeugt die nach dem Sieb des Eratosthenes aus Zs 
   ausgesiebte Liste Ps. */

gesiebt(N,[K|RZs],[K|RPs]) :- N > K*K, ohne_vielfache(K,RZs,Hs),
                              gesiebt(N,Hs,RPs).
gesiebt(N,[K|RZs],[K|RZs]) :- N =< K*K.

ohne_vielfache(X,[],[]).
ohne_vielfache(X,[K|Rs],[K|ROs]) :- 0 < K mod X, 
                                    ohne_vielfache(X,Rs,ROs).
ohne_vielfache(X,[K|Rs],ROs) :- 0 is K mod X, ohne_vielfache(X,Rs,ROs).
