eratosthenes(N,[2|Ps]) :- liste_u(3,N,Zs), gesiebt(N,Zs,Ps).


/* liste_u(A,B,Ls) erzeugt die Liste Ls aller ungeraden natrlichen 
   Zahlen von A bis B. */

liste_u(X,X,[X]) :- 1 is X mod 2.
liste_u(X,Y,[X]) :- 1 is X mod 2, Y is X + 1.
liste_u(A,E,[A|Rs]) :- A < E, A1 is A + 2, liste_u(A1,E,Rs).


/* gesiebt(N,Zs,Ps) erzeugt die nach dem Sieb des Eratosthenes aus Zs 
   ausgesiebte Liste Ps. */

gesiebt(N,[K|RZs],[K|RPs]) :- N > K*K, ohne_vielfache(K,RZs,Hs),
                              gesiebt(N,Hs,RPs).
gesiebt(N,[K|RZs],[K|RZs]) :- N =< K*K.

ohne_vielfache(X,[],[]).
ohne_vielfache(X,[K|Rs],[K|ROs]) :- 0 < K mod X, 
                                    ohne_vielfache(X,Rs,ROs).
ohne_vielfache(X,[K|Rs],ROs) :- 0 is K mod X, ohne_vielfache(X,Rs,ROs).
