/* Sortieren durch Auswahl
   -----------------------
   Aus einer Liste Ls wird das kleinste Element M ermittelt, die 
   Restliste Ms wird sortiert, und anschlieend setzt man M vor
   die sortierte Restliste. */

a_sortiert([X],[X]).   /* Rekursionsabbruch */
a_sortiert(Ls,[M|Rs]) :- kleinstes(Ls,M,Ms), a_sortiert(Ms,Rs).


/* kleinstes(Ls,M,Ms) heit: M ist das kleinste Element der Liste Ls,
   Ms ist die zu M gehrende Restliste von Ls. */
   
kleinstes([X],X,[]).   
kleinstes(Ls,M,Ms) :- minimum(M,Ls), geloescht(M,Ls,Ms).   

minimum(X,[K|Rs]) :- minimum(X,Rs), X < K, !.
minimum(K,[K|Rs]).

geloescht(K,[K|Rs],Rs).
geloescht(X,[K|Rs],[K|Ys]) :- geloescht(X,Rs,Ys).


/* Alternative Deklaration von kleinstes(Ls,M,Ms): 
   Zerlegt man Ls in Kopf K und Restliste Rs, so steckt das kleinste 
   Element M
   entweder im Rest der Liste,
   oder es ist der Kopf der Liste.
   Wenn die erste Bedingung erfllt ist, so schlgt die zweite garantiert
   fehl. Daher arbeiten mit Cut. 

kleinstes([X],X,[]).
kleinstes([K|Rs],M,[K|Ms]) :- kleinstes(Rs,M,Ms), K > M, !.
kleinstes([K|Rs],K,Rs).
*/


/* zliste(N,G,Ls) heit: Ls ist eine Liste von N Zufallszahlen von 1 
   bis G. */
   
zliste(0,G,[]).
zliste(N,G,[K|Rs]) :- N > 0, random(G,K), 
                      N1 is N - 1, zliste(N1,G,Rs).