/* Quicksort
   ---------
   Unter Quicksort versteht man folgendes Verfahren: Der Rest Rs einer
   Liste Ls wird in zwei Teile zerlegt, in die Liste Ks, die alle Elemente
   enthlt, die kleiner oder gleich dem Kopf K der Liste sind, und in die 
   Liste Gs, die alle Elemente enthlt, die grer als der Kopf der Liste
   sind. Ks und Gs werden jeweils sortiert und Ks und [K|Gs] zu der 
   sortierten Liste Qs zusammengefgt. */
   
q_sortiert([],[]).   /* Rekursionsabbruch */
q_sortiert([K|Rs],Qs) :- zerlegt(Rs,K,Ks,Gs), 
                         q_sortiert(Ks,K1s), q_sortiert(Gs,G1s),
                         append(K1s,[K|G1s],Qs).                         
                         
/* zerlegt(Ls,X,Ks,Gs) heit: Ls wird in die beiden Listen Ks und Gs zer-
   legt; Ks enthlt alle Elemente, die kleiner oder gleich X sind, Gs alle
   Elemente, die grer als X sind.
   Idee: Ist der Kopf der Liste kleiner oder gleich X, so wird er Kopf
   der Liste Ks hinzugefgt, sonst der Liste Gs. Ks und Gs sind die Listen,
   in die der Rest Rs zerlegt worden ist. */
                         
zerlegt([],X,[],[]).                         
zerlegt([K|Rs],X,[K|Ks],Gs) :- K =< X, zerlegt(Rs,X,Ks,Gs).
zerlegt([K|Rs],X,Ks,[K|Gs]) :- K > X, zerlegt(Rs,X,Ks,Gs).

/* append(Xs,Ys,Ls) heit: Ls entsteht durch Aneinanderhngen der Listen
   Xs und Ys. */
   
append([],Xs,Xs).
append([K|Rs],Xs,[K|Gs]) :- append(Rs,Xs,Gs).

                              