/* M1 = Anzahl der Missionare am Nordufer
   K1 = Anzahl der Kannibalen am Nordufer
   n,s = Ort des Bootes  */

/* vom Nord- zum Sdufer:  */

/* 0 Missionare */
benachbart(z(M1,K1,n),z(M1,K2,s)) :- 
   K2 >= 0, K2 =< M1, (K2 is K1 - 1; K2 is K1 - 2; K2 is K1 - 3).
/* 1 Missionar */
benachbart(z(M1,K1,n),z(M2,K2,s)) :- 
   M1 > 0, M2 is M1 - 1, (K2 is K1 - 1; K2 is K1).
   
benachbart(z(M1,K1,s),z(M2,K2,n)) :- 
   M is M1 - M2, M >= 0,
   K is K1 - K2, K >= 0,
   G is M + K, G > 0, G =< 3,
   M >= K, 
   M1 >= K1, M2 >= K2, K1 >= 0, K2 >= 0,
   K1 =< 3, M1 =< 3.   
   


/* Die Liste mit dem Element X wird so lange erweitert, bis der Kopf
   der Liste gleich Y ist. Um den Weg in der richtigen Reihenfolge zu
   erhalten, wird die Liste anschlieend invertiert. */
   
weg(X,Y,Ws) :- erweitert([X],[Y|Rs]), invers([Y|Rs],Ws).

/* Die Liste Ls wird schrittweise rekursiv zur Liste Es erweitert. 
   Das Ziel ist erreicht, wenn Ls = Es ist. */
   
erweitert(Es,Es). 
erweitert(Ls,Es) :- erweitert_um_1(Ls,Zws), erweitert(Zws,Es).

/* Ein benachbartes Element wird in die Liste aufgenommen, wenn es nicht
   bereis vorhanden ist. */
   
erweitert_um_1([K|Rs],[X,K|Rs]) :-
      benachbart(K,X), not element(X,[K|Rs]).

/* Erzeugt und prft Elemente einer Liste */      
element(K,[K|Rs]).
element(X,[K|Rs]) :- element(X,Rs).

/* invers(Ls,Is) heit: Is ist die zu Ls invertierte Liste. 
   Idee: Der Listenkopf wird an die invertierte Restliste angehngt. */

invers([],[]).
invers([K|Rs],Is) :- invers(Rs,Xs), append(Xs,[K],Is).

append([],Ls,Ls).
append([K|Rs],Ls,[K|Xs]) :- append(Rs,Ls,Xs).