von_nach(a,b).
von_nach(b,c).
von_nach(c,d).
von_nach(c,e).
von_nach(d,e).
von_nach(e,f).
von_nach(i,h).
von_nach(h,g).

benachbart(X,Y) :- von_nach(X,Y).
benachbart(X,Y) :- von_nach(Y,X).

/* Die Liste mit dem Element X wird so lange erweitert, bis der Kopf
   der Liste gleich Y ist. Um den Weg in der richtigen Reihenfolge zu
   erhalten, wird die Liste anschlieend invertiert. */
   
weg(X,Y,Ws) :- erweitert([X],[Y|Rs]), invers([Y|Rs],Ws).

/* Die Liste Ls wird schrittweise rekursiv zur Liste Es erweitert. 
   Das Ziel ist erreicht, wenn Ls = Es ist. */
   
erweitert(Es,Es). 
erweitert(Ls,Es) :- erweitert_um_1(Ls,Zws), erweitert(Zws,Es).

/* Ein benachbartes Element wird in die Liste aufgenommen, wenn es nicht
   bereis vorhanden ist. */
   
erweitert_um_1([K|Rs],[X,K|Rs]) :-
      benachbart(K,X), not element(X,[K|Rs]).

/* Erzeugt und prft Elemente einer Liste */      
element(K,[K|Rs]).
element(X,[K|Rs]) :- element(X,Rs), X \= K.

/* invers(Ls,Is) heit: Is ist die zu Ls invertierte Liste. 
   Idee: Der Listenkopf wird an die invertierte Restliste angehngt. */

invers([],[]).
invers([K|Rs],Is) :- invers(Rs,Xs), append(Xs,[K],Is).

append([],Ls,Ls).
append([K|Rs],Ls,[K|Xs]) :- append(Rs,Ls,Xs).